dim colorframe
dim RedSlide
dim GreenSlide
dim BlueSlide
dim myDC1
dim bmp1
dim bmp1a
dim colButton1
dim HColor

color_frame( 1 )

'Create a window

sub color_frame( event )

colorframe = new wxframe( Nothing, -1,"Color Maker" ,wxPoint(150,120))
colorframe.Setsize(368,440)

' add menubar to the colorframe
dim mBar = new wxMenuBar()
    colorframe.SetMenuBar(mBar)

' build the "File" dropdown menu
dim mFile = new wxMenu()
    mBar.Append(mFile, "Custom Color")

// create a "File" menu and append an item
mFile = new wxMenu()
mFile.Append( wxID_EXIT, "E&xit\tAlt-X", "Quit this program")

// create an "About" menu and append an item
mHelp = new wxMenu()
mHelp.Append( wxID_ABOUT, "Custom Color", "Choose a custom color")

// now append the freshly created menu to the menu bar...
menuBar = new wxMenuBar()
menuBar.Append(mFile, "&File")
menuBar.Append(mHelp, "&Color")

// ... and attach this menu bar to the colorframe
colorframe.SetMenuBar(menuBar)

'make some slider controls
'Slider control for the color red

RedLabel = new wxStaticText(colorframe,-1,"Red",wxPoint(15,3))
RedSlide = new wxSlider(colorframe, -1,0,0,255,wxPoint(15,25),wxSize(50,375),wxSL_LABELS | wxSL_AUTOTICKS | wxSL_VERTICAL)
RedSlide.SetTickFreq(5,1)
Connect (RedSlide,wxEVT_COMMAND_SLIDER_UPDATED,"ColorChange")

'Slider control for the color green

GreenLabel = new wxStaticText(colorframe,-1,"Green",wxPoint(75,3))
GreenSlide = new wxSlider(colorframe,-1,0,0,255,wxPoint(75,25),wxSize(50,375),wxSL_LABELS | wxSL_AUTOTICKS | wxSL_VERTICAL)
GreenSlide.SetTickFreq(5,1)
Connect (GreenSlide,wxEVT_COMMAND_SLIDER_UPDATED,"ColorChange")

'Slider control for the color blue

BlueLabel = new wxStaticText(colorframe,-1,"Blue",wxPoint(135,3))
BlueSlide = new wxSlider(colorframe,-1,0,0,255,wxPoint(135,25),wxSize(50,375),wxSL_LABELS | wxSL_AUTOTICKS | wxSL_VERTICAL)
BlueSlide.SetTickFreq(5,1)
Connect (BlueSlide,wxEVT_COMMAND_SLIDER_UPDATED,"ColorChange")

'Use a button to show the color being made


  bmp1a = New wxEmptyBitmap( 128, 128 )
  bmp1 = New wxEmptyBitmap( 128, 128 )
 co1 = new wxColour(0,0,0)

 myDC1 = new wxMemoryDC()
 myDC1.SelectObject(bmp1)

 myDC1.SetPen( wxPenFromColor( co1, 128, wxSOLID ) )
 myDC1.drawRectangle(0,0,128,128)
 myDC1.SelectObject(bmp1a)

 colButton1 = new wxBitmapButton( colorframe, -1, bmp1,wxPoint( 200, 3 ),wxSize(132,132),wxNO_3D  )



'HColor = wxStaticText(colorframe,-1,"",wxpoint(250,145))
HColor = wxTextCtrl(colorframe,-1,"",wxpoint(220,145))
HColor.SetForegroundColor(wxBlack)
HColor.SetBackgroundColor(wxWhite)
HColor.SetValue("#000000")

info = wxStaticText(colorframe,-1,"",wxPoint(250,165))


connect( colorframe, wxID_EXIT, wxEVT_COMMAND_MENU_SELECTED, "OnColorQuit" )
connect( colorframe, -1, wxEVT_CLOSE_WINDOW, "OnColorQuit" )


Connect( colorframe, wxID_ABOUT, wxEVT_COMMAND_MENU_SELECTED, "OnColorDialog" )

colorframe.Show(0) 

end sub

'This does the actual work

Sub ColorChange(event)
   Red = RedSlide.GetValue()
   Green = GreenSlide.GetValue()
   Blue = BlueSlide.GetValue()
   co = new wxColour(Red,Green,Blue)

    myDC1.SelectObject(bmp1)
    myDC1.SetPen( wxPenFromColor( co, 128, wxSOLID ) )
    myDC1.drawRectangle(0,0,128,128)
    myDC1.SelectObject(bmp1a)
    colButton1.show(0)
    colButton1.show(1)

   Select Case Red
      Case 0,1,2,3,4,5,6,7,8,9
          HexRed = "0" & Red
      Case 10,11,12,13,14,15
          HexRed = "0" & UCase(Hex(Red))
      Case else
          HexRed = Ucase(Hex(Red))
      End Select

   Select Case Green
      Case 0,1,2,3,4,5,6,7,8,9
         HexGreen = "0" & Green
      Case 10,11,12,13,14,15
         HexGreen = "0" & Ucase(Hex(Green))
      Case else
         HexGreen = Ucase(Hex(Green))
      End Select

   Select Case Blue
      Case 0,1,2,3,4,5,6,7,8,9
         HexBlue = "0" & Blue
      Case 10,11,12,13,14,15
         HexBlue = "0" & Ucase(Hex(Blue))
      Case else
         HexBlue = Ucase(Hex(Blue))
      End Select

   HColor.SetValue("#"&HexRed & HexGreen & HexBlue)

'whatis = butt.GetBackgroundColor()
'   info.SetLabel(whatis)

end Sub
Sub OnColorDialog( event )

    ' bring up the dialog
    dialog = New wxColorDialog( colorframe )
    dialog.ShowModal()
    colorData = dialog.GetColourData()
    color = colorData.GetColor()


    RedSlide.SetValue(color.Red())
    GreenSlide.SetValue(color.Green())
    BlueSlide.SetValue(color.Blue())
    
    ColorChange(1)   

End Sub

'// callback for the Quit menu option
function OnColorQuit( event )
    // TRUE is to force the colorframe to close
    colorframe.show(0)
end function

function OnColorShow( event )
    // TRUE is to force the colorframe to close
    colorframe.show(1)
    colorframe.raise()
end function


